using UnityEngine;using System.Collections.Generic;using System.Linq;namespace PluginIdea{    public class AdSorbData    {        public Vector3 point;        public Vector3 normal;    }    public class BlenderLikeAdsorb : BlenderLikeModuleBase    {        private List<string> adsorbTypeList = new List<string> { "HitPoint", "ClostController" };        private JSONStorableBool isUseAdsorb;        private JSONStorableStringChooser adsorbType;        private JSONStorableFloat normalShowLength;        private GLDraw gldraw;        private AdSorbData adsorbData;        private bool isAdsorbActive;        private Camera targetCamera;        public bool IsOpenAdsorb        {            get { return this.isUseAdsorb.val; }        }        public AdSorbData AdSorbData        {            get {                if (isAdsorbActive)                {                    return this.adsorbData;                }                SuperController.LogError("can't adsorb!");                return null;            }        }        public BlenderLikeAdsorb(BlenderLikeOperationPro ower)        {            this.ower = ower;            this.gldraw = new GLDraw();            this.targetCamera = SuperController.singleton.MonitorCenterCamera;        }        public override void Init()        {            InitUI();        }        private void InitUI()        {            Utils.SetupInfoText(ower, "<b>Is Adsorb: </b>When turned on, the object being dragged will automatically adsorb." +                " There are two modes." +                "ClostController: automatically adsorb to the nearest controller; HitPoint: adsorb to the mouse position." , 200, true);            Utils.SetupInfoTextNoScroll(ower, "<size=30><b>Adsorption</b></size>", 35, false);            isUseAdsorb = Utils.SetupToggle(ower, "Is Adsorb", false, false);            adsorbType = Utils.SetupStringChooser(ower, "AdsorptionMethod", adsorbTypeList, 1, false);            normalShowLength = Utils.SetupSliderFloat(ower, "NormalShowLength", 0.5f, 0.1f, 2f, false);        }        public void Update()        {            if (!isUseAdsorb.val) return;            if (adsorbType.val == adsorbTypeList[0])            {                Ray ray = targetCamera.ScreenPointToRay(Input.mousePosition);                RaycastHit hit;                if (Physics.Raycast(ray, out hit, Mathf.Infinity))                {                    adsorbData = new AdSorbData() { point = hit.point, normal = hit.normal };                    isAdsorbActive = true;                }                else                {                    isAdsorbActive = false;                }            }            else if (adsorbType.val == adsorbTypeList[1])            {                var controllersSelected = ower.SelectedControllers;                var freeControllers = SuperController.singleton.GetAllFreeControllers();                if (freeControllers.Count > 0)                {                    var minController = freeControllers[0];                    for (int i = 1; i < freeControllers.Count; i++)                    {                        if (!controllersSelected.Contains(freeControllers[i]))                        {                            float disMin = Vector3.Distance(targetCamera.WorldToScreenPoint(minController.transform.position), Input.mousePosition);                            float disCur = Vector3.Distance(targetCamera.WorldToScreenPoint(freeControllers[i].transform.position), Input.mousePosition);                            if (disMin > disCur)                            {                                minController = freeControllers[i];                            }                        }                    }                    isAdsorbActive = true;                    adsorbData = new AdSorbData() { normal = Vector3.up, point = minController.transform.position };                }                else                {                    isAdsorbActive = false;                }            }        }        public void OnPostRender()        {            if (!isUseAdsorb.val) return;            if (isAdsorbActive)            {                                if (adsorbType.val == adsorbTypeList[0])                {                                        GLQuad3D gLQuad3D = new GLQuad3D();                    Plane plane = new Plane(adsorbData.normal, adsorbData.point);                    Vector3 dir1 = (plane.ClosestPointOnPlane(new Vector3(0, 424, 232)) - adsorbData.point).normalized;                    Vector3 dir2 = Vector3.Cross(dir1, adsorbData.normal).normalized;                    Vector3 offset = adsorbData.normal * 0.001f;                    gLQuad3D.ld = adsorbData.point + dir1 + offset;                    gLQuad3D.lu = adsorbData.point + dir2 + offset;                    gLQuad3D.ru = adsorbData.point - dir1 + offset;                    gLQuad3D.rd = adsorbData.point - dir2 + offset;                    gldraw.DrawQuad3D(new List<GLQuad3D>() { gLQuad3D }, new Color(0, 0.5f, 0.5f, 0.1f));                                        Vector3 from = this.adsorbData.point;                    Vector3 to = this.adsorbData.point + adsorbData.normal * normalShowLength.val;                    gldraw.DrawLine3D(new List<GLLine3D>() { new GLLine3D() { from = from, to = to, color = Color.blue } }, null, Color.blue);                }                                else if (adsorbType.val == adsorbTypeList[1])                {                    var screenPoint = targetCamera.WorldToScreenPoint(this.adsorbData.point);                    Vector2 from = new Vector2() { x = screenPoint.x - 10, y = screenPoint.y };                    Vector2 to = new Vector2() { x = screenPoint.x + 10, y = screenPoint.y };                    Vector2 from1 = new Vector2() { x = screenPoint.x, y = screenPoint.y - 10 };                    Vector2 to1 = new Vector2() { x = screenPoint.x, y = screenPoint.y + 10 };                    gldraw.DrawLine2D(new List<GLLine2D> { new GLLine2D() { from = from, to = to }, new GLLine2D() { from = from1, to = to1 } }, Color.cyan);                    if (adsorbType.val == adsorbTypeList[1])                    {                        gldraw.DrawLine2D(new List<GLLine2D>() { new GLLine2D() { from = screenPoint, to = Input.mousePosition } }, Color.gray);                    }                }            }        }        public override void UnInit()        {        }    }}