using UnityEngine;using System.Collections.Generic;using System.Linq;namespace PluginIdea{    public class BlenderLikeSelection : BlenderLikeModuleBase    {        struct SelectMode        {            public const int ADD = 0;            public const int SUB = 1;        }        struct SelectState        {            public const int NONE = 0;            public const int BOXSELECT_READY = 1;        }        private JSONStorableBool isSelectLight;        private JSONStorableBool isSelectEmpty;        private JSONStorableBool isSelectSubScene;        private JSONStorableBool isSelectUIObject;        private GLDraw glDraw;        private Color rectColor;        private List<FreeControllerV3> atomControllers;        private int selectState;        private string[] AtomSelectExcudeArr = new string[] {            "CoreControl",            "PlayerNavigationPanel",            "WindowCamera",            "VRController"        };        private Vector2 start, end;        private bool isOnDrag;        private float mlbTimer;        public List<FreeControllerV3> FreeControllerV3s        {            get {                return this.atomControllers;            }        }        public List<Atom> AtomSelects        {            get {                return this.atomControllers.Select(x => Utils.GetAtomFromController(x)).Distinct().ToList();            }        }        public BlenderLikeSelection(BlenderLikeOperationPro ower)        {            this.glDraw = new GLDraw();            this.rectColor = new Color(0, 1, 0, 0.05f);            this.atomControllers = new List<FreeControllerV3>();            this.selectState = SelectState.NONE;            this.ower = ower;        }        public override void Init()        {            UIInit();        }        public void UIInit()        {            Utils.SetupInfoText(ower, "<b>Select: </b>" +               "leftCtrl + MouseLeft: box Select\n\n" +               "Ctrl+A : Select All. Ctrl+Shift+i : InverSelect. Mouse Center Click : Clear Select. Ctrl + N : System Select to Select", 400, true);            Utils.SetupInfoTextNoScroll(ower, "<size=30><b>Selection</b></size>", 35, false);            isSelectLight = Utils.SetupToggle(ower, "Is Select Light", true, false);            isSelectEmpty = Utils.SetupToggle(ower, "Is Select Empty", true, false);            isSelectSubScene = Utils.SetupToggle(ower, "Is Select SubScene", true, false);            isSelectUIObject = Utils.SetupToggle(ower, "Is Select UIObject", false, false);            Utils.SetupSpacer(ower, 30, false);        }        public void OnAppFocus(bool focus)        {            if (focus)            {                selectState = SelectState.NONE;            }        }        public void Update()        {            QuickSelect();            if (selectState == SelectState.NONE)            {                                bool lctr = Input.GetKey(KeyCode.LeftControl);                bool lalt = Input.GetKey(KeyCode.LeftAlt);                if (lctr || lalt)                {                    selectState = SelectState.BOXSELECT_READY;                }            }            if (Input.GetKeyUp(KeyCode.LeftControl) || Input.GetKeyUp(KeyCode.LeftShift) || Input.GetKeyUp(KeyCode.LeftAlt))            {                selectState = SelectState.NONE;            }        }        public void AppendSelection(FreeControllerV3 controllerV3)        {            if (!atomControllers.Contains(controllerV3))            {                atomControllers.Add(controllerV3);            }        }        private void QuickSelect()        {            bool lctr = Input.GetKey(KeyCode.LeftControl);            bool lalt = Input.GetKey(KeyCode.LeftAlt);            bool lmb0 = Input.GetMouseButtonDown(0);            bool lshift = Input.GetKey(KeyCode.LeftShift);            if (Input.GetMouseButton(2))            {                mlbTimer += Time.deltaTime;            }                        if (Input.GetMouseButtonUp(2))            {                ClearSelect();            }                        else if (lctr && lshift && Input.GetKeyDown(KeyCode.I))            {                InverseSelect();            }                        else if (lctr && Input.GetKeyDown(KeyCode.A))            {                SelectAll();            }                        else if (lctr && Input.GetKeyDown(KeyCode.N))            {                SelectFromSuperControllerSelect();            }        }        public void SelectFromSuperControllerSelect()        {            FreeControllerV3 controller = SuperController.singleton.GetSelectedController();            if (controller != null)            {                ClearSelect();                atomControllers.Add(controller);            }        }        public void ClearSelect()        {            if (mlbTimer < 0.2f)            {                atomControllers.Clear();                ower.HudHander.HUDStr = "Cleared Selected Objects";            }            mlbTimer = 0;        }        public void SelectAll()        {            ower.HudHander.HUDStr = "Select All";            atomControllers = SuperController.singleton.GetAllFreeControllers();        }        public void InverseSelect()        {            ower.HudHander.HUDStr = "Inverse Select";            List<FreeControllerV3> tmpList = new List<FreeControllerV3>();            if (atomControllers.Count > 0)            {                SuperController.singleton.GetAllFreeControllers().ForEach(ctr =>                {                    if (!atomControllers.Contains(ctr))                    {                        tmpList.Add(ctr);                    }                });            }            atomControllers = tmpList;        }        private List<FreeControllerV3> GetControllersFromAtoms(List<Atom> atoms)        {            List<FreeControllerV3> controllers = new List<FreeControllerV3>();            if (atoms.Count > 0)            {                atoms.ForEach(atom => {                    var controller = Utils.GetControllerFromAtom(atom);                    if (controller != null)                    {                        controllers.Add(controller);                    }                });            }            return controllers;        }        private void ClearSelectionNullObject()        {            if (atomControllers.Count > 0)            {                for (int i = 0; i < atomControllers.Count; i++)                {                    if (atomControllers[i] == null)                    {                        atomControllers.RemoveAt(i);                    }                }            }        }        public void OnPostRender()        {            if (selectState == SelectState.BOXSELECT_READY)            {                                if (Input.GetMouseButton(0))                {                    if (!isOnDrag)                    {                        isOnDrag = true;                        start = new Vector2(Input.mousePosition.x, Input.mousePosition.y);                    }                    end = new Vector2(Input.mousePosition.x, Input.mousePosition.y);                    glDraw.DrawQuad2D(new Rect(start, new Vector2(end.x - start.x, end.y - start.y)), rectColor);                    if (Input.GetKey(KeyCode.LeftControl))                    {                        ower.HudHander.HUDStr = "Box Select (Add Mode)";                    }                    else if (Input.GetKey(KeyCode.LeftAlt))                    {                        ower.HudHander.HUDStr = "Box Select (Subtract Mode)";                    }                }                if (Input.GetMouseButtonUp(0))                {                    isOnDrag = false;                                        ClearSelectionNullObject();                                        if (Input.GetKey(KeyCode.LeftControl))                    {                        SelecitonsSync(SelectMode.ADD);                    }                    else if (Input.GetKey(KeyCode.LeftAlt))                    {                        SelecitonsSync(SelectMode.SUB);                    }                }            }                        if (atomControllers.Count > 0)            {                for (int i = 0; i < atomControllers.Count; i++)                {                    Vector3 targetObjectPosition = atomControllers[i].transform.position;                    Camera monitorCenterCamera = SuperController.singleton.MonitorCenterCamera;                    float distanceObjectToCamera = Vector3.Distance(targetObjectPosition, monitorCenterCamera.transform.position);                    var anchorPosition = monitorCenterCamera.WorldToScreenPoint(targetObjectPosition);                    Rect rect = new Rect(anchorPosition.x, anchorPosition.y, 100 / distanceObjectToCamera, 100 / distanceObjectToCamera);                                        glDraw.DrawQuad2D(rect, Color.red);                }            }        }        private bool IsAtomCanSelect(Atom atom)        {            return isSelectEmpty.val && atom.type == "Empty" ||                isSelectLight.val && atom.type.Contains("Light") ||                isSelectSubScene.val && atom.type == "SubScene" ||                isSelectUIObject.val && atom.type.StartsWith("UI") ||                (atom.type != "Empty" && !atom.type.Contains("Light") && atom.type != "SubScene" && !atom.type.StartsWith("UI") && !AtomSelectExcudeArr.Contains(atom.type));        }        private void SelecitonsSync(int selectMode)        {            SuperController.singleton.GetAllFreeControllers().ForEach(ctr => {                if (IsAtomCanSelect(Utils.GetAtomFromController(ctr)))                {                                        var mainWindowCamera = SuperController.singleton.MonitorCenterCamera;                    var screenPositon = mainWindowCamera.WorldToScreenPoint(ctr.transform.position);                    Vector2 min = new Vector2(Mathf.Min(start.x, end.x), Mathf.Min(start.y, end.y));                    Vector2 max = new Vector2(Mathf.Max(start.x, end.x), Mathf.Max(start.y, end.y));                    if (screenPositon.x >= min.x && screenPositon.x < max.x && screenPositon.y >= min.y && screenPositon.y < max.y)                    {                        if (selectMode == SelectMode.ADD)                        {                            if (!atomControllers.Contains(ctr))                            {                                atomControllers.Add(ctr);                                SuperController.LogMessage(string.Format("controller Selected, atom: {0}", Utils.GetAtomFromController(ctr).uid));                            }                        }                        else if (selectMode == SelectMode.SUB)                        {                            if (atomControllers.Contains(ctr))                            {                                atomControllers.Remove(ctr);                                SuperController.LogMessage(string.Format("controller UnSelected, atom: {0}", Utils.GetAtomFromController(ctr).uid));                            }                        }                    }                }            });        }        public override void UnInit()        {        }    }}