using UnityEngine;using System.Collections.Generic;using UnityEngine.UI;using UnityEngine.EventSystems;using UnityEngine.Events;using MeshVR;using System;namespace PluginIdea{    public class CallbackData    {        public string text;        public Action callback;    }    public class ContexMenuView : BlenderLikeModuleBase    {        private Canvas popupCanvas;        private List<CallbackData> callbacks;        private GameObject buttonTemplate;        private GameObject panelObj;        private float rbmHoldTime;        public ContexMenuView(BlenderLikeOperationPro ower)        {            this.ower = ower;            this.callbacks = new List<CallbackData>();        }        public override void Init()        {            Utils.SetupInfoText(ower, "<b>Contex Menu: </b>" +                "leftCtrl + MouseRight to Open ContexMenu", 100, true);            popupCanvas = Utils.AppendCanvasObjectUnderHeadCenter("ContexViewSpaceCanvas", true);            var canvasObj = popupCanvas.gameObject;            var assetsBundlePath = Utils.GetPluginPath(ower) + "/resources/contex_panel.assetbundle";            AssetLoader.AssetBundleFromFileRequest request = new AssetLoader.AssetBundleFromFileRequest { path = assetsBundlePath, callback = OnAssetBundleLoaded };            AssetLoader.QueueLoadAssetBundleFromFile(request);        }        public void RegisterButtonEvent(CallbackData callbackData)        {            if (!this.callbacks.Contains(callbackData))            {                this.callbacks.Add(callbackData);            }        }        public void Update()        {            if (Input.GetMouseButtonDown(1))            {                rbmHoldTime = 0;            }            rbmHoldTime += Time.deltaTime;                        if (Input.GetKey(KeyCode.LeftControl) && Input.GetMouseButtonUp(1) && rbmHoldTime < 0.17f)            {                Vector2 anchorPosition;                RectTransform parentRectTrans = popupCanvas.GetComponent<RectTransform>();                RectTransform panelRectTrans = panelObj.GetComponent<RectTransform>();                if (RectTransformUtility.ScreenPointToLocalPointInRectangle(parentRectTrans, Input.mousePosition, popupCanvas.worldCamera, out anchorPosition))                {                    panelRectTrans.anchoredPosition = anchorPosition;                }                panelObj.SetActive(true);            }            if (Input.GetMouseButtonDown(0) && !EventSystem.current.IsPointerOverGameObject())            {                panelObj.SetActive(false);            }        }        public void CreateContexMenuItems()        {            if (this.callbacks.Count > 0)            {                callbacks.ForEach(cd => {                    var buttonObj = GameObject.Instantiate<GameObject>(buttonTemplate, panelObj.transform);                    buttonObj.SetActive(true);                    Button buttonComp = buttonObj.GetComponent<Button>();                    buttonObj.GetComponentInChildren<Text>().text = cd.text;                    buttonComp.onClick.AddListener(new UnityAction(() => {                        panelObj.SetActive(false);                        if (cd.callback != null) cd.callback();                    }));                });            }        }        private void OnAssetBundleLoaded(AssetLoader.AssetBundleFromFileRequest abffr)        {            try            {                var panelPrefab = abffr.assetBundle.LoadAsset<GameObject>("ContexPanel");                panelObj = GameObject.Instantiate<GameObject>(panelPrefab, popupCanvas.transform);                panelObj.transform.localRotation = Quaternion.identity;                panelObj.transform.localScale = Vector3.one;                panelObj.transform.localPosition = Vector3.zero;                buttonTemplate = panelObj.transform.GetChild(0).gameObject;                CreateContexMenuItems();                panelObj.SetActive(false);            }            catch (Exception e)            {                SuperController.LogError(e.Message);                throw;            }        }        public override void UnInit()        {            if (popupCanvas != null)            {                callbacks.Clear();                callbacks = null;                GameObject.Destroy(popupCanvas.gameObject);            }        }    }}