using UnityEngine;using System.Collections.Generic;using System.Linq;namespace PluginIdea{    public class UnDoReDoManager    {        private UndoRedoData undoRedoData = new UndoRedoData();        public void Record(int type, List<DraggedObjectTransInfo> transInfos)        {            if (transInfos.Count > 0)            {                List<int> uids = new List<int>();                List<Vector3> controllerV3s = new List<Vector3>();                switch (type)                {                    case UndoRedoType.MOVE:                        UndoRedoMoveItemData moveItemData = new UndoRedoMoveItemData();                        moveItemData.type = type;                        transInfos.ForEach(transInfo => {                            if (transInfo != null)                            {                                uids.Add(transInfo.instanceID);                                controllerV3s.Add(transInfo.position);                            }                        });                        moveItemData.positions = controllerV3s;                        moveItemData.uids = uids;                        undoRedoData.Push(moveItemData);                        break;                    case UndoRedoType.ROTATE:                        UndoRedoRotateItemData rotateItemData = new UndoRedoRotateItemData();                        rotateItemData.type = type;                        transInfos.ForEach(transInfo => {                            if (transInfo != null)                            {                                uids.Add(transInfo.instanceID);                                controllerV3s.Add(transInfo.eulerAngle);                            }                        });                        rotateItemData.uids = uids;                        rotateItemData.rotateEulers = controllerV3s;                        undoRedoData.Push(rotateItemData);                        break;                    case UndoRedoType.SCALE:                        UndoRedoScaleItemData scaleItemData = new UndoRedoScaleItemData();                        scaleItemData.type = type;                        transInfos.ForEach(transInfo => {                            if (transInfo != null)                            {                                uids.Add(transInfo.instanceID);                                controllerV3s.Add(transInfo.localScale);                            }                        });                        scaleItemData.uids = uids;                        scaleItemData.scales = controllerV3s;                        undoRedoData.Push(scaleItemData);                        break;                    case UndoRedoType.ADD:                        UndoRedoAddItemData addItemData = new UndoRedoAddItemData();                        transInfos.ForEach(transInfo => {                            uids.Add(transInfo.instanceID);                        });                        addItemData.type = type;                        addItemData.uids = uids;                        undoRedoData.Push(addItemData);                        break;                    case UndoRedoType.REMOVE:                        break;                    default:                        break;                }            }        }        public void Undo()        {            UndoRedoItemDataBase tmpItem = undoRedoData.UndoPop();            ApplyUndoOperation(tmpItem);        }        public void Redo()        {            UndoRedoItemDataBase tmpItem = undoRedoData.RedoPop();            ApplyUndoOperation(tmpItem);        }        private static void ApplyUndoOperation(UndoRedoItemDataBase tmpItem)        {            switch (tmpItem.type)            {                case UndoRedoType.MOVE:                    UndoRedoMoveItemData moveData = tmpItem as UndoRedoMoveItemData;                    if (moveData.uids.Count > 0)                    {                        int index = 0;                        moveData.uids.ForEach(uid =>                        {                            var controller = Utils.GetFreeControllerV3ByInstanceID(uid);                            controller.transform.position = moveData.positions[index];                            index++;                        });                    }                    break;                case UndoRedoType.ROTATE:                    UndoRedoRotateItemData rotateData = tmpItem as UndoRedoRotateItemData;                    if (rotateData.uids.Count > 0)                    {                        int index = 0;                        rotateData.uids.ForEach(uid =>                        {                            var controller = Utils.GetFreeControllerV3ByInstanceID(uid);                            controller.transform.eulerAngles = rotateData.rotateEulers[index];                            index++;                        });                    }                    break;                case UndoRedoType.SCALE:                    UndoRedoScaleItemData scaleData = tmpItem as UndoRedoScaleItemData;                    if (scaleData.uids.Count > 0)                    {                        int index = 0;                        scaleData.uids.ForEach(uid =>                        {                            var controller = Utils.GetFreeControllerV3ByInstanceID(uid);                            Transform scaleTransform;                            var controllerTransform = controller.transform;                            SetTransformScale setTransformScale = controller.GetComponentInParent<SetTransformScale>();                            if (setTransformScale == null)                            {                                scaleTransform = controllerTransform.parent.Find("object/rescaleObject").transform;                            }                            else                            {                                scaleTransform = setTransformScale.transform;                            }                            scaleTransform.transform.localScale = scaleData.scales[index];                            SuperController.LogMessage(scaleData.scales[index].ToString());                            index++;                        });                    }                    break;                case UndoRedoType.ADD:                    UndoRedoAddItemData addData = tmpItem as UndoRedoAddItemData;                    if (addData.uids.Count > 0)                    {                        addData.uids.ForEach(uid =>                        {                            var atom = Utils.GetAtomFromInstanceID(uid);                            SuperController.singleton.RemoveAtom(atom);                        });                    }                    break;                default:                    break;            }        }    }}